-module(refanal_list).

-export([analyse/0]).

-include("core.hrl").

analyse()->
    AllFunc = ?Graph:path(?Graph:root(), [{module, {name, '==', lists}}, func]),
    AllFuncRefs = [{{reflib_function:name(Func),
                     reflib_function:arity(Func)},
                    ?Graph:path(Func, [{funeref, back}])} || Func <- AllFunc],
    {{map, 2}, MapRefs} = lists:keyfind({map,2}, 1, AllFuncRefs),
    try analyse_maps(MapRefs)
    catch 
        _:_ -> ok
    end.

analyse_maps([M | Tail])->
    [Pars] = ?Graph:path(M, [{esub, 2}]),
    [FunExpr, List] = ?Graph:path(Pars, [esub]),
    Reach = refanal_message:run(fun()-> ?Dataflow:reach_1st([List], 
                                                        [{back, true}]) 
                                end),
    ListElements = reflib_query:exec(Reach, [{cons_e, back}]),
    case reflib_expression:type(FunExpr) of
        fun_expr -> 
            [Par] = ?Graph:path(FunExpr, [{exprcl, 1}, {pattern, 1}]),
            [?Graph:mklink(E, flow, Par) || E <- ListElements]
    end,
    analyse_maps(Tail);
analyse_maps([]) ->
    ok.
