%%% -*- coding: latin-1 -*-

%%% The  contents of this  file are  subject to  the Erlang  Public License,
%%% Version  1.1, (the  "License");  you may  not  use this  file except  in
%%% compliance  with the License.  You should  have received  a copy  of the
%%% Erlang  Public License  along  with this  software.  If not,  it can  be
%%% retrieved at http://plc.inf.elte.hu/erlang/
%%%
%%% Software  distributed under  the License  is distributed  on an  "AS IS"
%%% basis, WITHOUT  WARRANTY OF ANY  KIND, either expressed or  implied. See
%%% the License  for the specific language governing  rights and limitations
%%% under the License.
%%%
%%% The Original Code is RefactorErl.
%%%
%%% The Initial Developer of the  Original Code is Eötvös Loránd University.
%%% Portions created  by Eötvös  Loránd University are  Copyright 2009,
%%% Eötvös Loránd University. All Rights Reserved.

%%% @author Viktoria Fordos <v@fviktoria.hu>

%% -*- mode: nitrogen -*-
-module (action_notification).
-include_lib("nitrogen/include/wf.hrl").
-include("records.hrl").
-compile(export_all).

render_action(Record) ->

    %Color=case Record#notification.type of
        %notification -> "#33FF33";
        %warning -> "#FFFF33";
        %_ -> "#FF3333"
    %end,
    Text=split_label_into_rows(Record#notification.text),
    Type=case Record#notification.type of
        notification -> "notice";
        warning -> "warning";
        _ -> "error"
    end,
    %Id=wf:temp_id(),
    %wf:remove(wf:session(last_notification)),
    %wf:session(last_notification,Id),
    %InnerPanel = #panel {class=notification, style="background-color: "++Color, body=[
            %#link { class=close_button, text="Close", actions=#event { type=click, target=Id, actions=#fade { speed=200 } } },
            %#panel { class=textarea, body=Text}
        %]},
    %Notif=#panel { id=Id, style="display: none;", body=InnerPanel},
    %wf:insert_top(pagetop,Notif),
    %wf:wire(Id, #appear { speed=200 }),
    "
    if (typeof lasttoast != 'undefined') $().toastmessage('removeToast', lasttoast);
    lasttoast=$().toastmessage('showToast', {
    text     : '"++Text++"',
    sticky   : true,
    position:  'bottom-right',
    type     : '"++Type++"'
    });".
    
split_label_into_rows(Text) when length(Text)<100 ->
    [Text];
split_label_into_rows(Text)->
    {List1,List2}=lists:split(100,Text),
    lists:flatten(List1++"<br />"++split_label_into_rows(List2)).
