%%% -*- coding: latin-1 -*-

%%% The  contents of this  file are  subject to  the Erlang  Public License,
%%% Version  1.1, (the  "License");  you may  not  use this  file except  in
%%% compliance  with the License.  You should  have received  a copy  of the
%%% Erlang  Public License  along  with this  software.  If not,  it can  be
%%% retrieved at http://plc.inf.elte.hu/erlang/
%%%
%%% Software  distributed under  the License  is distributed  on an  "AS IS"
%%% basis, WITHOUT  WARRANTY OF ANY  KIND, either expressed or  implied. See
%%% the License  for the specific language governing  rights and limitations
%%% under the License.
%%%
%%% The Original Code is RefactorErl.
%%%
%%% The Initial Developer of the  Original Code is Etvs Lornd University.
%%% Portions created  by Etvs  Lornd University are  Copyright 2009,
%%% Etvs Lornd University. All Rights Reserved.

%%% @author Viktoria Fordos <f-viktoria@elte.hu>

%%% @doc This action is designed to limit the access to the database.
%%%
%%% In the case of any job should not be requested, then the following command 
%%% should be called: <pre>wf:wire(#toggle_access_to_db{enable = false}).</pre>
%%% 
%%% In the case of any job can be requested, then the following command 
%%% should be called: <pre>wf:wire(#toggle_access_to_db{enable = true}).</pre>

-module(action_toggle_access_to_db).
-compile (export_all).
-include_lib ("nitrogen/include/wf.hrl").
-include("records.hrl").

-vsn("$Rev: 9080 $ ").

render_action(#toggle_access_to_db{enable = true}) ->
    wf:session(disablethings,undefined),
    "$('input.need_db, button.need_db, select.need_db').removeAttr('disabled');
     $('input.need_db, button.need_db, select.need_db').removeClass('disabled');
     $('div.need_db').css('display','none');
     $('a.need_db, img.need_db').css('display','');";
render_action(#toggle_access_to_db{enable = false}) ->
    wf:session(disablethings,true),
    "$('input.need_db, button.need_db, select.need_db').attr('disabled', 'disabled');
     $('input.need_db, button.need_db, select.need_db').addClass('disabled');
     $('div.need_db').css('display','block');
     $('a.need_db, img.need_db').css('display','none');".
